' (c) wellCAM CCS, LUBLIN
'
' Historia zmian:
' Data      Kto                 Co
' ========  ==================  ======================================
' 03.05.98  Romek Zaorski       Pierwsza wersja
'

Dim vDia As Variant                                      'Szerokosc fasolki uzyto Variant dla prostszej obslugi InputBox
Dim vLen As Variant                                      'Dlugosc fasolki uzyto Variant dla prostszej obslugi InputBox

' Makro to rysuje otwor fasolkowy
Sub Main
        Dim doc As Object                               'Arkusz roboczy na ktory bedzie wstawiana fasolka
        Set doc = Application.ActiveDocument            'Ustawienie  jako arkusz roboczy arkusz z aktywnego okna
        Dim dwg As Object                               'Definowanie obiektu dwg
        Set dwg = doc.Drawing                           'Przypisanie obiektu dwg jako rysunek arkusza roboczego

	Dim idx As Long
        idx = dwg.AddObject()                           'Stwrz nowy obiekt rysunkowy i zapamietaj jego indeks
                                                        'ktory jest zwracany przez funkcje .AddObject
	                                                                                                  ' swoj indeks. Tworzac go przypisujemy mu indeks zwracany przez
	                                                                                                  ' funkcje  .AddObject
        If (idx > 0) Then                               'Jesli udalo sie stworzyc obiekt rysunkowy
                dwg.OpenObject(idx)                     'Otwrz obiekt w celu dodania grafiki. Identyfikatorem jest tu idx
                If DrawSymbol(dwg, 0, 0) Then         'Jesli narysowano fasolke. Jest to wywolanie funkcjii DrawSymbol z parametrem obiektu dwg i punktem wstawienia
                        dwg.SetPointORD(0, 0)          'Punkt orientacyjny obiektu
                        dwg.CloseObject()                       'Zamknij obiekt
                        dwg.ExecuteString("SUW(mode=OSTOBI,p=[0,0])")   'Ustawia dynamicznie przesuwanie obiektu
                        'dwg.ExecuteString("KOP(mode=LSTCMP)")   'Kopiuje dynamicznie przesuwanie obiektu
                Else
                        dwg.CloseObject()                       'Zamknij obiekt
                End If

	End If

End Sub

'Podprogram - rysowanie fasolki
Function DrawSymbol(dwg As Object, x As Double, y As Double) As Boolean
        Dim ret As Boolean 'wartosc zwracana przez funkcje. Falsz jesli przerwano lub blednie wprowadzono dane
        ret = False
        ' wprowadzanie danych przy pomocy InputBox
        vLen= InputBox("Podaj dlugosc")
        If Len(vLen) > 0 And IsNumeric(vLen) Then                      'Jesli podano jakos dlugosc. Nacisniecie ESC zwraca stringo o dlug = 0
                vDia=InputBox("Podaj szerokosc")
                If Len(vDia) > 0 And IsNumeric(vDia) Then              'Jesli podano jakos szerokos. Nacisniecie ESC zwraca stringo o dlug = 0
                        dwg.AddLine x-vLen/2+vDia/2, y-vDia/2, x+vLen/2-vDia/2, y-vDia/2, 1, -1 'Dolny bok fasolki
                        dwg.AddArc  x-vLen/2+vDia/2, y, vDia/2, 90, 270, 1, -1                'Lewy luk fasolki
                        dwg.AddLine x-vLen/2+vDia/2, y+vDia/2, x+vLen/2-vDia/2, y+vDia/2, 1, -1 'Gorny bok fasolki
                        dwg.AddArc  x+vLen/2-vDia/2, y, vDia/2 , 270, 90, 1, -1          'Prawy luk fasolki
                'rysuj oie
                        dwg.AddLine x-vLen/2-0.2*vDia ,y, x+vLen/2 + 0.2*vDia, y, 4, 14                                                ' os pozioma przedluzon o 0.2*vLen
                        dwg.AddLine x, y+vDia/2+0.2*vDia, x, y-vDia/2-0.2*vDia, 4, 14             'Os srodkowa przedluzona 0 0.2*vDia
                        If Val(vLen) > 4*Val(vDia) Then 'jesli dlugosc jest wieksza od 4 srednic rysuj osie lukow
                                dwg.AddLine x-vLen/2+vDia/2, y+vDia/2+0.1*vDia, x-vLen/2+vDia/2, y-vDia/2-0.1*vDia, 4, 14           'Os pionowa lewa  przedluzon 0 0.1*vDia
                                dwg.AddLine x+vLen/2-vDia/2, y+vDia/2+0.1*vDia, x+vLen/2-vDia/2, y-vDia/2-0.1*vDia, 4, 14 'Os pionowa prawa przedluzona o 0.1*Vdia
                        End If
                        ret = True 'gdyz dodano obiekt
                End If
       End If
       DrawSymbol = ret
End Function
